/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* ddot.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal ddot_ (n, dx, incx, dy, incy)
     integer *n;
     doublereal *dx;
     integer *incx;
     doublereal *dy;
     integer *incy;
{
   /* System generated locals */
   integer i__1, i__2;
   doublereal ret_val;

   /* Local variables */
   static integer i__, m, ix, iy, ns, mp1;

/* ***BEGIN PROLOGUE  DDOT */
/* ***DATE WRITTEN   791001   (YYMMDD) */
/* ***REVISION DATE  820801   (YYMMDD) */
/* ***CATEGORY NO.  D1A4 */
/* ***KEYWORDS  BLAS,DOUBLE PRECISION,INNER PRODUCT,LINEAR ALGEBRA,VECTOR */
/* ***AUTHOR  LAWSON, C. L., (JPL) */
/*           HANSON, R. J., (SNLA) */
/*           KINCAID, D. R., (U. OF TEXAS) */
/*           KROGH, F. T., (JPL) */
/* ***PURPOSE  D.P. inner product of d.p. vectors */
/* ***DESCRIPTION */

/*                B L A S  Subprogram */
/*    Description of Parameters */

/*     --Input-- */
/*        N  number of elements in input vector(s) */
/*       DX  double precision vector with N elements */
/*     INCX  storage spacing between elements of DX */
/*       DY  double precision vector with N elements */
/*     INCY  storage spacing between elements of DY */

/*     --Output-- */
/*     DDOT  double precision dot product (zero if N .LE. 0) */

/*     Returns the dot product of double precision DX and DY. */
/*     DDOT = sum for I = 0 to N-1 of  DX(LX+I*INCX) * DY(LY+I*INCY) */
/*     where LX = 1 if INCX .GE. 0, else LX = (-INCX)*N, and LY is */
/*     defined in a similar way using INCY. */
/* ***REFERENCES  LAWSON C.L., HANSON R.J., KINCAID D.R., KROGH F.T., */
/*                 *BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE*, */
/*                 ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL */
/*                 SOFTWARE, VOLUME 5, NUMBER 3, SEPTEMBER 1979, 308-323 */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  DDOT */

/* ***FIRST EXECUTABLE STATEMENT  DDOT */
   /* Parameter adjustments */
   --dy;
   --dx;

   /* Function Body */
   ret_val = 0.;
   if (*n <= 0)
   {
      return ret_val;
   }
   if (*incx == *incy)
   {
      if ((i__1 = *incx - 1) < 0)
      {
         goto L5;
      }
      else if (i__1 == 0)
      {
         goto L20;
      }
      else
      {
         goto L60;
      }
   }
 L5:

/*         CODE FOR UNEQUAL OR NONPOSITIVE INCREMENTS. */

   ix = 1;
   iy = 1;
   if (*incx < 0)
   {
      ix = (-(*n) + 1) * *incx + 1;
   }
   if (*incy < 0)
   {
      iy = (-(*n) + 1) * *incy + 1;
   }
   i__1 = *n;
   for (i__ = 1; i__ <= i__1; ++i__)
   {
      ret_val += dx[ix] * dy[iy];
      ix += *incx;
      iy += *incy;
/* L10: */
   }
   return ret_val;

/*        CODE FOR BOTH INCREMENTS EQUAL TO 1. */

/*        CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 5. */

 L20:
   m = *n % 5;
   if (m == 0)
   {
      goto L40;
   }
   i__1 = m;
   for (i__ = 1; i__ <= i__1; ++i__)
   {
      ret_val += dx[i__] * dy[i__];
/* L30: */
   }
   if (*n < 5)
   {
      return ret_val;
   }
 L40:
   mp1 = m + 1;
   i__1 = *n;
   for (i__ = mp1; i__ <= i__1; i__ += 5)
   {
      ret_val = ret_val + dx[i__] * dy[i__] + dx[i__ + 1] * dy[i__ + 1] +
         dx[i__ + 2] * dy[i__ + 2] + dx[i__ + 3] * dy[i__ + 3] + dx[i__ +
                                                                    4] *
         dy[i__ + 4];
/* L50: */
   }
   return ret_val;

/*         CODE FOR POSITIVE EQUAL INCREMENTS .NE.1. */

 L60:
   ns = *n * *incx;
   i__1 = ns;
   i__2 = *incx;
   for (i__ = 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2)
   {
      ret_val += dx[i__] * dy[i__];
/* L70: */
   }
   return ret_val;
}                                       /* ddot_ */
