/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* eltran.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int eltran_ (nm, n, low, igh, a, int__, z__)
     integer *nm, *n, *low, *igh;
     doublereal *a;
     integer *int__;
     doublereal *z__;
{
   /* System generated locals */
   integer a_dim1, a_offset, z_dim1, z_offset, i__1, i__2;

   /* Local variables */
   static integer i__, j, kl, mm, mp, mp1;

/* ***BEGIN PROLOGUE  ELTRAN */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C4 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Accumulates the stabilized elementary similarity */
/*            transformations used in the reduction of a DOUBLE PRECISION general */
/*            matrix to upper Hessenberg form by ELMHES. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure ELMTRANS, */
/*     NUM. MATH. 16, 181-204(1970) by Peters and Wilkinson. */
/*     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971). */

/*     This subroutine accumulates the stabilized elementary */
/*     similarity transformations used in the reduction of a */
/*     DOUBLE PRECISION GENERAL matrix to upper Hessenberg form by  ELMHES. */

/*     On INPUT */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        LOW and IGH are integers determined by the balancing */
/*          subroutine  BALANC.  If  BALANC  has not been used, */
/*          set LOW=1, IGH=N. */

/*        A contains the multipliers which were used in the */
/*          reduction by  ELMHES  in its lower triangle */
/*          below the subdiagonal. */

/*        INT contains information on the rows and columns */
/*          interchanged in the reduction by  ELMHES. */
/*          only elements LOW through IGH are used. */

/*     On OUTPUT */

/*        Z contains the transformation matrix produced in the */
/*          reduction by  ELMHES. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  ELTRAN */

/* ***FIRST EXECUTABLE STATEMENT  ELTRAN */
   /* Parameter adjustments */
   z_dim1 = *nm;
   z_offset = z_dim1 + 1;
   z__ -= z_offset;
   --int__;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   i__1 = *n;
   for (i__ = 1; i__ <= i__1; ++i__)
   {

      i__2 = *n;
      for (j = 1; j <= i__2; ++j)
      {
/* L60: */
         z__[i__ + j * z_dim1] = 0.;
      }

      z__[i__ + i__ * z_dim1] = 1.;
/* L80: */
   }

   kl = *igh - *low - 1;
   if (kl < 1)
   {
      goto L200;
   }
/*     .......... FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- .......... */
   i__1 = kl;
   for (mm = 1; mm <= i__1; ++mm)
   {
      mp = *igh - mm;
      mp1 = mp + 1;

      i__2 = *igh;
      for (i__ = mp1; i__ <= i__2; ++i__)
      {
/* L100: */
         z__[i__ + mp * z_dim1] = a[i__ + (mp - 1) * a_dim1];
      }

      i__ = int__[mp];
      if (i__ == mp)
      {
         goto L140;
      }

      i__2 = *igh;
      for (j = mp; j <= i__2; ++j)
      {
         z__[mp + j * z_dim1] = z__[i__ + j * z_dim1];
         z__[i__ + j * z_dim1] = 0.;
/* L130: */
      }

      z__[i__ + mp * z_dim1] = 1.;
    L140:
      ;
   }

 L200:
   return 0;
}                                       /* eltran_ */
