/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* tred2.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int tred2_ (nm, n, a, d__, e, z__)
     integer *nm, *n;
     doublereal *a, *d__, *e, *z__;
{
   /* System generated locals */
   integer a_dim1, a_offset, z_dim1, z_offset, i__1, i__2, i__3;
   doublereal d__1;

   /* Builtin functions */
   double sqrt (), d_sign ();

   /* Local variables */
   static doublereal f, g, h__;
   static integer i__, j, k, l;
   static doublereal scale, hh;
   static integer ii, jp1;

/* ***BEGIN PROLOGUE  TRED2 */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C1B1 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Reduce DOUBLE PRECISION symmetric matrix to symmetric tridiagonal */
/*            matrix using and accumulating orthogonal transformation */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure TRED2, */
/*     NUM. MATH. 11, 181-195(1968) by Martin, Reinsch, and Wilkinson. */
/*     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971). */

/*     This subroutine reduces a DOUBLE PRECISION SYMMETRIC matrix to a */
/*     symmetric tridiagonal matrix using and accumulating */
/*     orthogonal similarity transformations. */

/*     On Input */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        A contains the DOUBLE PRECISION symmetric input matrix.  Only the */
/*          lower triangle of the matrix need be supplied. */

/*     On Output */

/*        D contains the diagonal elements of the tridiagonal matrix. */

/*        E contains the subdiagonal elements of the tridiagonal */
/*          matrix in its last N-1 positions.  E(1) is set to zero. */

/*        Z contains the orthogonal transformation matrix */
/*          produced in the reduction. */

/*        A and Z may coincide.  If distinct, A is unaltered. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  TRED2 */

/* ***FIRST EXECUTABLE STATEMENT  TRED2 */
   /* Parameter adjustments */
   z_dim1 = *nm;
   z_offset = z_dim1 + 1;
   z__ -= z_offset;
   --e;
   --d__;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   i__1 = *n;
   for (i__ = 1; i__ <= i__1; ++i__)
   {

      i__2 = i__;
      for (j = 1; j <= i__2; ++j)
      {
         z__[i__ + j * z_dim1] = a[i__ + j * a_dim1];
/* L100: */
      }
   }

   if (*n == 1)
   {
      goto L320;
   }
/*     .......... FOR I=N STEP -1 UNTIL 2 DO -- .......... */
   i__2 = *n;
   for (ii = 2; ii <= i__2; ++ii)
   {
      i__ = *n + 2 - ii;
      l = i__ - 1;
      h__ = 0.;
      scale = 0.;
      if (l < 2)
      {
         goto L130;
      }
/*     .......... SCALE ROW (ALGOL TOL THEN NOT NEEDED) .......... */
      i__1 = l;
      for (k = 1; k <= i__1; ++k)
      {
/* L120: */
         scale += (d__1 = z__[i__ + k * z_dim1], abs (d__1));
      }

      if (scale != 0.)
      {
         goto L140;
      }
    L130:
      e[i__] = z__[i__ + l * z_dim1];
      goto L290;

    L140:
      i__1 = l;
      for (k = 1; k <= i__1; ++k)
      {
         z__[i__ + k * z_dim1] /= scale;
         h__ += z__[i__ + k * z_dim1] * z__[i__ + k * z_dim1];
/* L150: */
      }

      f = z__[i__ + l * z_dim1];
      d__1 = sqrt (h__);
      g = -d_sign (&d__1, &f);
      e[i__] = scale * g;
      h__ -= f * g;
      z__[i__ + l * z_dim1] = f - g;
      f = 0.;

      i__1 = l;
      for (j = 1; j <= i__1; ++j)
      {
         z__[j + i__ * z_dim1] = z__[i__ + j * z_dim1] / h__;
         g = 0.;
/*     .......... FORM ELEMENT OF A*U .......... */
         i__3 = j;
         for (k = 1; k <= i__3; ++k)
         {
/* L180: */
            g += z__[j + k * z_dim1] * z__[i__ + k * z_dim1];
         }

         jp1 = j + 1;
         if (l < jp1)
         {
            goto L220;
         }

         i__3 = l;
         for (k = jp1; k <= i__3; ++k)
         {
/* L200: */
            g += z__[k + j * z_dim1] * z__[i__ + k * z_dim1];
         }
/*     .......... FORM ELEMENT OF P .......... */
       L220:
         e[j] = g / h__;
         f += e[j] * z__[i__ + j * z_dim1];
/* L240: */
      }

      hh = f / (h__ + h__);
/*     .......... FORM REDUCED A .......... */
      i__1 = l;
      for (j = 1; j <= i__1; ++j)
      {
         f = z__[i__ + j * z_dim1];
         g = e[j] - hh * f;
         e[j] = g;

         i__3 = j;
         for (k = 1; k <= i__3; ++k)
         {
            z__[j + k * z_dim1] = z__[j + k * z_dim1] - f * e[k] - g *
               z__[i__ + k * z_dim1];
/* L260: */
         }
      }

    L290:
      d__[i__] = h__;
/* L300: */
   }

 L320:
   d__[1] = 0.;
   e[1] = 0.;
/*     .......... ACCUMULATION OF TRANSFORMATION MATRICES .......... */
   i__2 = *n;
   for (i__ = 1; i__ <= i__2; ++i__)
   {
      l = i__ - 1;
      if (d__[i__] == 0.)
      {
         goto L380;
      }

      i__3 = l;
      for (j = 1; j <= i__3; ++j)
      {
         g = 0.;

         i__1 = l;
         for (k = 1; k <= i__1; ++k)
         {
/* L340: */
            g += z__[i__ + k * z_dim1] * z__[k + j * z_dim1];
         }

         i__1 = l;
         for (k = 1; k <= i__1; ++k)
         {
            z__[k + j * z_dim1] -= g * z__[k + i__ * z_dim1];
/* L360: */
         }
      }

    L380:
      d__[i__] = z__[i__ + i__ * z_dim1];
      z__[i__ + i__ * z_dim1] = 1.;
      if (l < 1)
      {
         goto L500;
      }

      i__1 = l;
      for (j = 1; j <= i__1; ++j)
      {
         z__[i__ + j * z_dim1] = 0.;
         z__[j + i__ * z_dim1] = 0.;
/* L400: */
      }

    L500:
      ;
   }

   return 0;
}                                       /* tred2_ */
