/* Header file for ibd_haplo programs -- taking stuff out of ibd_haplo.c */
/*  Program to do a basic analysis of IBD inference with no LD */
/*  Up to 4 genomes, or genotypic pairs  */


typedef struct _Chromseg
{
   int   fgl;
   double endpos;
} Chromseg;

typedef struct _Chromseglist
{
   struct _Chromseg *current;
   struct _Chromseglist *next;
} Chromseglist;

int   skipmark;                   /* number of markers skipped in analysis */

double **pprob, *penmat;          /* nph pheno, ns states */
double **transmat;                /* ns x ns transition matrix */
                                  /* penmat and transmat now reset each locus */
                                  /*  and penmat only for given data */
double tmat[15][15];
int tmatset = 0;

double hh, gg, delta;             /* Parameters of the Q-matrix */
double  fkin, ffrate;             /* Parameters of population IBD */

int   igin;                       /* indicator of genotypic data on input   */
int   igdx;                       /* indicator of genotypic data for anal.  */

