/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int proc_free (void)
{
   /* Free the data structures defined in parsepars.h.                        */

/* UNLNKD_PTR p_unl; */
   SIM_PTR p_sim;
   MAP_PTR p_map;
   VMAP_PTR p_vmp;
   LOCUS_PTR p_loc;
   INCO_PENE_PTR p_ipn;
   GENO_MEANS_PTR p_gmn;
   VARI_PTR p_var;
   MARKDAT_PTR p_mrk;
   PROBGAM_PTR p_prb;
   LOCWND_PTR p_locwnd;
   WNDPAT_PTR p_windpat;

   TLLIST_PTR p_trl;
   PRNTMAP_PTR p_prt;
   PRDIST_PTR p_prl;

   void *p_nxt, *p_nxl;
   int   sx;

#if 0
   /* Free the memory used for unlnkd_node's.                                 */
   p_unl = first_unlnkd_node;
   while (p_unl)
   {
      p_nxt = p_unl->p_next;
      free (p_unl);
      p_unl = p_nxt;
   }
   first_unlnkd_node = NULL;
#endif

   /* Free the memory used for sim_chrom_node's.                              */
   p_sim = first_sim_chrom_node;
   while (p_sim)
   {
      p_nxt = p_sim->p_next;
      if (p_sim->p_mark)
         free (p_sim->p_mark);
      free (p_sim);
      p_sim = p_nxt;
   }
   first_sim_chrom_node = NULL;

   /* Free the memory used for marker map_node's and dist_list's.             */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_map = first_mark_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         if (p_map->p_dist)
            free (p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_mark_map_node[sx] = NULL;
   }

   /* Free the memory used for tloc map_node's and dist_list's.               */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_map = first_tloc_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         if (p_map->p_dist)
            free (p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_tloc_map_node[sx] = NULL;
   }

   /* Free the memory used for tloc vmap_node's and positions.                */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_vmp = first_tloc_vmap_node[sx];
      while (p_vmp)
      {
         p_nxt = p_vmp->p_next;
         if (p_vmp->p_pos)
            free (p_vmp->p_pos);
         if (p_vmp->p_beg)
            free (p_vmp->p_beg);
         if (p_vmp->p_end)
            free (p_vmp->p_end);
         if (p_vmp->p_intv)
            free (p_vmp->p_intv);
         free (p_vmp);
         p_vmp = p_nxt;
      }
      first_tloc_vmap_node[sx] = NULL;
   }

   /* Free the memory used for marker locus_node's.                           */
   p_loc = first_mark_locus_node;
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0) /* Decrement number of loci */
      {                                 /* Remove freq_node if no ptrs.       */
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_mark_locus_node = NULL;

   /* Free the memory used for tloc locus_node's.                             */
   p_loc = first_tloc_locus_node;
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0)
      {
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_tloc_locus_node = NULL;

   /* Free the memory used for inco_pene_node's.                              */
   p_ipn = first_inco_pene_node;
   while (p_ipn)
   {
      p_nxt = p_ipn->p_next;
      if (p_ipn->penetrances)
         free (p_ipn->penetrances);
      free (p_ipn);
      p_ipn = p_nxt;
   }
   first_inco_pene_node = NULL;

   /* Free the memory used for geno_means_node's.                             */
   p_gmn = first_geno_means_node;
   while (p_gmn)
   {
      p_nxt = p_gmn->p_next;
      if (p_gmn->means)
         free (p_gmn->means);
      free (p_gmn);
      p_gmn = p_nxt;
   }
   first_geno_means_node = NULL;

   /* Free the memory used for additive vari_node's.                          */
   p_var = first_addi_node;
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_addi_node = NULL;

   /* Free the memory used for residual vari_node's.                          */
   p_var = first_resi_node;
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_resi_node = NULL;

   /* Free the memory used for markdat_node's.                                */
   p_mrk = first_markdat_node;
   while (p_mrk)
   {
      p_nxt = p_mrk->p_next;
      if (p_mrk->p_obs)
         free (p_mrk->p_obs);
      if (p_mrk->p_alls)
         free (p_mrk->p_alls);
      free (p_mrk);
      p_mrk = p_nxt;
   }
   first_markdat_node = NULL;

   /* Free the memory used for probgam_node's.                                */
   p_prb = first_probgam_node;
   while (p_prb)
   {
      p_nxt = p_prb->p_next;
      if (p_prb->p_pglist)
         free (p_prb->p_pglist);
      free (p_prb);
      p_prb = p_nxt;
   }
   first_probgam_node = NULL;

   /* Free the memory used for locwind_node's.                                */
   p_locwnd = first_locwind_node;
   while (p_locwnd)
   {
      p_nxt = p_locwnd->p_next;
      free (p_locwnd);
      p_locwnd = p_nxt;
   }
   first_locwind_node = NULL;

   /* Free the memory used for windpat_node's.                                */
   p_windpat = first_windpat_node;
   while (p_windpat)
   {
      p_nxt = p_windpat->p_next;
      free (p_windpat);
      p_windpat = p_nxt;
   }
   first_windpat_node = NULL;

   /* Free the data structures defined in parsedrop.h.                        */

   /* Free the memory used for tllist_node's.                                 */
   p_trl = first_tllist_node;
   while (p_trl)
   {
      p_nxt = p_trl->p_next;
      free (p_trl);
      p_trl = p_nxt;
   }
   first_tllist_node = NULL;

   /* Free the memory used for printmap_node's.                               */
   for (sx = FEM; sx <= AVG; ++sx)
   {
      p_prt = first_prntmap_node[sx];
      while (p_prt)
      {
         p_nxt = p_prt->p_next;
         p_prl = p_prt->p_locus;
         while (p_prl)
         {
            p_nxl = p_prl->p_next;
            free (p_prl);
            p_prl = p_nxl;
         }
         free (p_prt);
         p_prt = p_nxt;
      }
      first_prntmap_node[sx] = NULL;
   }

   return TRUE;
}
