#include "mulmsample.h"
/* Global variables used in this function:
   n_compnts, pedsize, cmplist;

   global variables changed in this function:
   NMarrs, marr, indmarr, cmpmarr

   Routine rewritten and much simplified; EAT Nov 2008
     Removed: Several linked lists and other variables removed.
     Added: Use of DebugSample to omit extraneous output.
*/

/* assign values to Nmarr, marr and indmarr */
void setup_marriage (void)
{
   int   c, i1, i2, nk, nkm;
   int   kk, kkm, nmr, nmc;

   Marrglist *marhead, *marcurr, *marlast;

   Indlist *pind, *pk;
   Marlist *pm;
   Component *pc;

   cmpmarr = malloc (n_compnts * sizeof (Marrg));
   alloc_chk (WHERE, cmpmarr);
   indmarr = malloc (pedsize * sizeof (IndMarrg));
   alloc_chk (WHERE, indmarr);

   for (i1 = 0; i1 < pedsize; ++i1)
      indmarr[i1].nmarr = 0;

   marhead = malloc (sizeof (Marrglist));
   alloc_chk (WHERE, marhead);
   marhead->current = NULL;
   marhead->next = NULL;

   NMarrs = 0;
   marlast = marhead;
   for (c = 0, pc = cmplist + 1; c < n_compnts; c++, pc++)
   {
      nmc = 0;                          /* number of marriages in component c */
      cmpmarr[c].c = c + 1;
      /* in the case of Global MCMC, all the meioses are considered; 
         otherwise, consider only the large components */
      if (GlobalMcmc || (pc->nmeioses > MaxNMexact))
      {

         if (DebugSample)
         {
            printf ("\n component = %d ", c + 1);
            fflush (stdout);
         }

         pind = pc->people->next;       /* pointer to indidual in component c */
         while (pind)
         {
            if (pind->current->sex == FEMALE)
            {
               i1 = pind->current->index;
               if (DebugSample)
               {
                  printf ("\n processing individual %s index %d",
                          pind->current->self, pind->current->index);
               }
               pm = pind->current->marriages; /* pointer to marriages of i1 */
               while (pm)               /* i1 has marriages */
               {
                  /* i2 is the index of spouse */
                  i2 = pm->current->spouse->index;

                  ++indmarr[i1].nmarr;
                  ++indmarr[i2].nmarr;

                  indmarr[i1].index = i1;
                  indmarr[i1].c = c + 1;
                  indmarr[i2].index = i2;
                  indmarr[i2].c = c + 1;
                  if (DebugSample)
                  {
                     printf (" and spouse = %s", nghd[i2].self);
                     fflush (stdout);
                  }

                  nmc++;
                  if (DebugSample)
                  {
                     printf ("\n number of marriages is now %d", nmc);
                     fflush (stdout);
                  }
                  marlast->next = malloc (sizeof (Marrglist));
                  alloc_chk (WHERE, marlast->next);
                  marlast = marlast->next;
                  marlast->current = malloc (sizeof (Marrg));
                  alloc_chk (WHERE, marlast->current);

                  marlast->current->wife = i1;
                  marlast->current->husb = i2;
                  marlast->current->index = NMarrs;
                  marlast->current->c = c + 1;

                  NMarrs++;
                  if (DebugSample)
                  {
                     printf ("\n total number of marriages is now %d", NMarrs);
                     fflush (stdout);

                     /* i1 should be a female */

                     printf ("\n       No. of marriages of %s = %d",
                             nghd[i1].self, indmarr[i1].nmarr);
                     printf ("\n       No. of marriages of %s = %d",
                             nghd[i2].self, indmarr[i2].nmarr);
                     fflush (stdout);
                  }
                  /* find nkid and nkidmeio */
                  nk = nkm = 0;         /* no. of kids and kid meioses */
                  pk = pm->current->kids; /* ptr to kids in current marriage */
                  while (pk)
                  {
                     nk++;
                     if (pk->current->matmeio > 0)
                        nkm++;
                     if (pk->current->patmeio > 0)
                        nkm++;

                     pk = pk->next;
                  }
                  marlast->current->nkid = nk;
                  marlast->current->nkidmeio = nkm;

                  if (DebugSample)
                     printf ("\n no. of kid = %d, no. of kid meioses = %d",
                             nk, nkm);

                  /* assign values to kid and kidmeio */
                  marlast->current->kid = NULL;
                  marlast->current->kidmeio = NULL;
                  if (nk)
                  {
                     al_int_vector (&(marlast->current->kid), nk);
                     al_int_vector (&(marlast->current->kidmeio), nkm);

                     pk = pm->current->kids;
                     kk = kkm = 0;
                     while (pk)
                     {
                        marlast->current->kid[kk++] = pk->current->index;
                        if (pk->current->matmeio > 0)
                           marlast->current->kidmeio[kkm++] =
                              pk->current->matmeio;
                        if (pk->current->patmeio > 0)
                           marlast->current->kidmeio[kkm++] =
                              pk->current->patmeio;
                        pk = pk->next;
                     }                  /* end of while (pk) */

                  }                     /* end of if (nk) */

                  pm = pm->next;
               }                        /* end of while (pm) */
            }

            pind = pind->next;
         }
         if (DebugSample)
         {
            printf (" \n Number marriages cmpnt %d is %d", c + 1, nmc);
            fflush (stdout);
         }
      }                                 /* end of while (pind) */

      cmpmarr[c].nmarr = nmc;
   }                                    /* end of for (c = 0;...) */
   marlast->next = NULL;

   /* assign values to marr */
   marr = NULL;
   if (NMarrs > 0)
   {
      marr = malloc (NMarrs * sizeof (Marrg));
      kk = 0;
      marlast = marhead->next;
      while (marlast)
      {
         marr[kk] = *(marlast->current);
         kk++;
         marlast = marlast->next;
      }
   }

   /* assign values to cmpmarr[c].marr */
   nk = 0;
   for (c = 0; c < n_compnts; c++)
   {
      nmr = cmpmarr[c].nmarr;
      cmpmarr[c].marr = NULL;
      if (nmr)
      {
         al_int_vector (&(cmpmarr[c].marr), nmr);
         for (kk = 0; kk < nmr; kk++)
            cmpmarr[c].marr[kk] = nk++;
      }
   }
   /* Now finally  assign values to indmarr[i1].marr  and indmarr[i2].marr */
   /* We now assign these after processing the marriages EAT 10/2008 */
/*  First we must set up the vectors of indmarr, or right size;
    Also, for each individual, need to know where we are at
     --maybe reset indmarr.nmar to 0 ?? */

   for (kk = 0; kk < pedsize; kk++)
   {
      i1 = nghd[kk].index;
      indmarr[i1].marr = NULL;
      nmr = indmarr[i1].nmarr;
      if (nmr)
      {
         al_int_vector (&(indmarr[i1].marr), nmr);
         indmarr[i1].nmarr = 0;
      }
   }

/* Then we go through the marriages setting indmarr[].marr*/

   for (c = 0; c < n_compnts; c++)
   {
      if (cmpmarr[c].nmarr > 0)
      {
         printf ("\n For Component %2d \n", cmpmarr[c].c);
         printf ("\n Number of marriages = %2d \n", cmpmarr[c].nmarr);
         for (kk = 0; kk < cmpmarr[c].nmarr; kk++)
         {
            kkm = cmpmarr[c].marr[kk];
            i1 = nghd[marr[kkm].wife].index;
            i2 = indmarr[i1].nmarr;
            indmarr[i1].marr[i2] = marr[kkm].index;
            ++indmarr[i1].nmarr;

            i1 = nghd[marr[kkm].husb].index;
            i2 = indmarr[i1].nmarr;
            indmarr[i1].marr[i2] = marr[kkm].index;
            ++indmarr[i1].nmarr;

         }
      }
   }

   /* free the chain start with marhead */
   while (marhead)
   {
      free (marhead->current);
      marcurr = marhead->next;
      free (marhead);
      marhead = marcurr;
   }

   return;
}

void prnt_marriage (void)
{
   int   c, k, t;
   int   mi;                            /* marriage indices */

   /* print cmpmarr and marr */
   if (DebugSample)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (cmpmarr[c].nmarr > 0)
         {
            printf ("\n For Component %2d \n", cmpmarr[c].c);
            printf ("\n Number of marriages = %2d \n", cmpmarr[c].nmarr);
            for (k = 0; k < cmpmarr[c].nmarr; k++)
            {
               mi = cmpmarr[c].marr[k];
               printf ("\n For the %2d th marriage:", marr[mi].index + 1);
               printf ("\n wife = %s, husb = %s, nkid = %2d, nkidmeio = %2d",
                       nghd[marr[mi].wife].self, nghd[marr[mi].husb].self,
                       marr[mi].nkid, marr[mi].nkidmeio);
               printf ("\n Kids list:\n");
               for (t = 0; t < marr[mi].nkid; t++)
                  printf (" %s", nghd[marr[mi].kid[t]].self);
               printf ("\n Kids' meioses list:\n");
               for (t = 0; t < marr[mi].nkidmeio; t++)
                  printf (" %d", marr[mi].kidmeio[t]);
               printf ("\n");
            }
         }
      }
   }
   printf ("\n === Setup for marriage structure completed === \n\n\n");

   return;
}

void free_marriage (void)
{
   int   k;

   if (marr)
   {
      for (k = 0; k < NMarrs; k++)
      {
         if (marr[k].kid)
            free_1d ((void *) &(marr[k].kid));
         if (marr[k].kidmeio)
            free_1d ((void *) &(marr[k].kidmeio));
      }
      free (marr);
      marr = NULL;
   }
   if (indmarr)
   {
      for (k = 0; k < pedsize; k++)
      {
         if (indmarr[k].marr)
            free_1d ((void *) &(indmarr[k].marr));
      }
      free (indmarr);
      indmarr = NULL;
   }
   if (cmpmarr)
   {
      for (k = 0; k < n_compnts; k++)
      {
         if (cmpmarr[k].marr)
            free_1d ((void *) &(cmpmarr[k].marr));
      }
      free (cmpmarr);
      cmpmarr = NULL;
   }
   return;
}
